import sys
from PyQt4 import QtGui, QtCore
from mrbayespanel import Ui_Dialog

def calcProb(estimate,probwithbug,probwithoutbug,repros,nonrepros):
    last=estimate
    for i in range(0,repros):
        last=last*probwithbug/(last*probwithbug+(1-last)*probwithoutbug)
    for i in range(0,nonrepros):
        last=last*(1-probwithbug)/(1-(last*probwithbug+(1-last)*probwithoutbug))


    last2=estimate
    for i in range(0,nonrepros):
        last2=last2*(1-probwithbug)/(1-(last2*probwithbug+(1-last2)*probwithoutbug))
    for i in range(0,repros):
        last2=last2*probwithbug/(last2*probwithbug+(1-last2)*probwithoutbug)

    #print(str(last) + " vs " + str(last2))
    # pointless error minimization exercise    
    return (last+last2)/2 

def getFloat(lineEdit):
    return float(lineEdit.text())

def recalculate(dialog):
    def recalculatefn():
        #print("calculating")
        a=getFloat(dialog.lineEdit_estimate)
        b=getFloat(dialog.lineEdit_bug)
        c=getFloat(dialog.lineEdit_nobug)
        d=dialog.spinBox_success.value()
        e=dialog.spinBox_fail.value()
        finalprob=calcProb(a,b,c,d,e)
        if (finalprob<0.0001):
            finalprob=0.0001
        dialog.lineEdit_finalprobability.setText(str(finalprob))
    return recalculatefn

def main():
    app = QtGui.QApplication(sys.argv)

    window = QtGui.QDialog()
    ui = Ui_Dialog()

    ui.setupUi(window)

    app.connect(ui.lineEdit_estimate, QtCore.SIGNAL("textChanged(QString)"),recalculate(ui) )
    app.connect(ui.lineEdit_bug, QtCore.SIGNAL("textChanged(QString)"),recalculate(ui) )
    app.connect(ui.lineEdit_nobug, QtCore.SIGNAL("textChanged(QString)"),recalculate(ui) )
    app.connect(ui.spinBox_success, QtCore.SIGNAL("valueChanged(int)"),recalculate(ui) )
    app.connect(ui.spinBox_fail, QtCore.SIGNAL("valueChanged(int)"),recalculate(ui) )

    recalculate(ui)()
    
    window.show()

    
    sys.exit(app.exec_())

if __name__ == '__main__':
    main()
